<template>
  <GI18nCard
    v-if="signature"
    i18n="dcc.signature.title"
    optional
    @deleteElement="deleteSignature"
  >
    <v-alert v-if="error" type="error" class="mt-4">
      {{ $t("dcc.signature.validationError") }}<br />
      {{ error }}
    </v-alert>
    <v-alert v-else-if="valid === false" type="error" class="mt-4">
      {{ $t("dcc.signature.invalid") }}
    </v-alert>
    <v-alert v-if="valid === true" type="success" class="mt-4">
      {{ $t("dcc.signature.valid") }}
    </v-alert>
    <v-alert type="info" class="mt-4">
      Signature information is displayed below. The signature is not validated
      yet.
    </v-alert>
    <v-simple-table>
      <thead>
        <tr>
          <th></th>
          <th>{{ $t("dcc.signature.value") }}</th>
        </tr>
      </thead>
      <tbody>
        <tr>
          <td>{{ $t("dcc.signature.signingTime") }}</td>
          <td>{{ signature.signingTime }}</td>
        </tr>
        <tr>
          <td>{{ $t("dcc.signature.cert.subject") }}</td>
          <td>{{ signature.cert.subject }}</td>
        </tr>
        <tr>
          <td>{{ $t("dcc.signature.cert.issuer") }}</td>
          <td>{{ signature.cert.issuer }}</td>
        </tr>
        <tr>
          <td>{{ $t("dcc.signature.cert.serialNumber") }}</td>
          <td>{{ signature.cert.serialNumber }}</td>
        </tr>
        <tr>
          <td>{{ $t("dcc.signature.cert.notBefore") }}</td>
          <td>{{ signature.cert.notBefore }}</td>
        </tr>
        <tr>
          <td>{{ $t("dcc.signature.cert.notAfter") }}</td>
          <td>{{ signature.cert.notAfter }}</td>
        </tr>
      </tbody>
    </v-simple-table>
  </GI18nCard>
</template>

<script>
import * as XAdES from "xadesjs";
import * as x509 from "@peculiar/x509";
import GI18nCard from "~/components/App/Common/GI18nCard.vue";

export default {
  name: "Signature",
  components: {
    GI18nCard,
  },
  data() {
    return {
      signature: null,
      error: null,
      valid: null,
    };
  },
  mounted() {
    this.$tool.on("dccLoaded", this.onDccLoaded);
  },
  beforeDestroy() {
    this.$tool.off("dccLoaded", this.onDccLoaded);
  },
  methods: {
    getDsTag(signature, tagName) {
      return signature.getElementsByTagNameNS(
        "http://www.w3.org/2000/09/xmldsig#",
        tagName
      );
    },
    getXadesTag(signature, tagName) {
      return signature.getElementsByTagNameNS(
        "http://uri.etsi.org/01903/v1.3.2#",
        tagName
      );
    },
    extractSignature(signature) {
      const signingTime = this.getXadesTag(signature, "SigningTime")[0]
        ?.textContent;

      const base64 = this.getDsTag(signature, "X509Certificate")[0]
        ?.textContent;
      const cert = new x509.X509Certificate(base64);

      return {
        signingTime,
        cert: {
          issuer: cert.issuer,
          subject: cert.subject,
          serialNumber: cert.serialNumber,
          notAfter: cert.notAfter.toISOString(),
          notBefore: cert.notBefore.toISOString(),
        },
      };
    },
    onDccLoaded({ dccDocument }) {
      this.signature = null;
      this.error = null;
      this.valid = null;

      try {
        const signedDoc = XAdES.Parse(dccDocument.toXML());
        const xmlSignature = signedDoc.getElementsByTagNameNS(
          "http://www.w3.org/2000/09/xmldsig#",
          "Signature"
        );

        if (xmlSignature.length > 0) {
          this.signature = this.extractSignature(xmlSignature[0]);
          /* disable signature validation for now
          this.$logger.info("Signature found, verifying...", xmlSignature[0]);
          const signedXml = new XAdES.SignedXml(signedDoc);
          signedXml.LoadXml(xmlSignature[0]);

          this.valid = await signedXml.Verify(); */
        }
      } catch (e) {
        this.$logger.error(e);
        this.error = e.message;
      }
    },
    deleteSignature() {
      if (!confirm(this.$t("dcc.signature.confirmRemove"))) return;

      this.signature = null;
      this.error = null;
      this.valid = null;

      this.$delete(
        this.$global.dccDocument.digitalCalibrationCertificate,
        "ds:Signature"
      );
    },
  },
};
</script>
